From dee9fa3853d4b073ad7defe77834ce197a941a4a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 21 2020 22:40:50 +0000
Subject: [PATCH 1764/2232] Simplify Pair to fully qualified


---

diff --git a/syntax/names.rs b/syntax/names.rs
index 523850e..586c017 100644
--- a/syntax/names.rs
+++ b/syntax/names.rs
@@ -32,19 +32,17 @@ impl Pair {
     }
 
     pub fn to_fully_qualified(&self) -> String {
-        format!("::{}", self.join("::"))
+        let mut fully_qualified = String::new();
+        for segment in self.iter_all_segments() {
+            fully_qualified += "::";
+            fully_qualified += &segment.to_string();
+        }
+        fully_qualified
     }
 
     fn iter_all_segments(&self) -> impl Iterator<Item = &Ident> {
         self.namespace.iter().chain(iter::once(&self.cxx))
     }
-
-    fn join(&self, sep: &str) -> String {
-        self.iter_all_segments()
-            .map(|s| s.to_string())
-            .collect::<Vec<_>>()
-            .join(sep)
-    }
 }
 
 impl RustName {

